=== Tests/RunCMake/CTest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
if(NOT NoProject)
  project(${RunCMake_TEST} NONE)
endif()
include(${RunCMake_TEST}.cmake)
