=== Tests/RunCMake/set_property/TEST-subdir1/CMakeLists.txt ===
add_test(NAME t COMMAND ${CMAKE_COMMAND} -E echo "Subdirectory")
add_test(NAME t2 COMMAND ${CMAKE_COMMAND} -E echo "Subdirectory")
add_test(NAME t3 COMMAND ${CMAKE_COMMAND} -E echo "Subdirectory")
